<?php
add_action('after_setup_theme', 'stallion_setup');
add_action('wp_head', 'stallion_setup2');

if (!function_exists('stallion_setup')):

function stallion_setup() {
if ( ! isset( $content_width ) ) $content_width = 1000;
load_theme_textdomain('stallion', get_template_directory() . '/languages');
add_editor_style();
$custom_header_support = array(
#'default-image'=> get_stylesheet_directory_uri() . '',
'header-text' => true,
'default-text-color' => 'f7f7f7',
'width' => apply_filters( 'stallion_header_image_width', 1000 ),
'flex-width' => true,
'height' => apply_filters( 'stallion_header_image_height', 288 ),
'flex-height' => true,
'random-default' => true,
'wp-head-callback' => 'stallion_header_style', // Template header style callback
'admin-head-callback' => 'stallion_admin_header_style', // Admin header style callback
'admin-preview-callback' => 'stallion_admin_header_image' // Admin preview style callback
);
#if (function_exists('get_custom_header')) {

add_theme_support( 'custom-header', $custom_header_support );

if ( ! function_exists( 'get_custom_header' ) ) {
// This is all for compatibility with versions of WordPress prior to 3.4.
define( 'HEADER_TEXTCOLOR', $custom_header_support['default-text-color'] );
define( 'HEADER_IMAGE', '' );
define( 'HEADER_IMAGE_WIDTH', $custom_header_support['width'] );
define( 'HEADER_IMAGE_HEIGHT', $custom_header_support['height'] );
add_custom_image_header( $custom_header_support['wp-head-callback'], $custom_header_support['admin-head-callback'], $custom_header_support['admin-preview-callback'] );
add_custom_background();
}

add_image_size( 'large-feature', $custom_header_support['width'], $custom_header_support['height'], true );

$stmeta2011headeror = stct_header_2011_images();

if (file_exists(STYLESHEETPATH . '/headers/' . $stmeta2011headeror . '/image-01.jpg')) {
$head2011dir = get_bloginfo('stylesheet_directory');
} else {
$head2011dir = get_bloginfo('template_url');
}

register_default_headers(array(
'st_head01' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-01.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-01-thumbnail.jpg',
'description' => __('Stallion Header 1', 'stallion')
),
'st_head02' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-02.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-02-thumbnail.jpg',
'description' => __('Stallion Header 2', 'stallion')
),
'st_head03' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-03.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-03-thumbnail.jpg',
'description' => __('Stallion Header 3', 'stallion')
),
'st_head04' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-04.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-04-thumbnail.jpg',
'description' => __('Stallion Header 4', 'stallion')
),
'st_head05' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-05.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-05-thumbnail.jpg',
'description' => __('Stallion Header 5', 'stallion')
),
'st_head06' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-06.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-06-thumbnail.jpg',
'description' => __('Stallion Header 6', 'stallion')
),
'st_head07' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-07.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-07-thumbnail.jpg',
'description' => __('Stallion Header 7', 'stallion')
),
'st_head08' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-08.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-08-thumbnail.jpg',
'description' => __('Stallion Header 8', 'stallion')
)
));
}

endif; // stallion_setup

if (!function_exists('stallion_setup2')):

function stallion_setup2() {

global $post;
if ( (is_single() || is_page()) && get_post_meta($post->ID, 'st_meta_2011header_or', true) )
: $stmeta2011headeror = get_post_meta($post->ID, 'st_meta_2011header_or', true);
else : $stmeta2011headeror = stct_header_2011_images();
endif;

if (file_exists(STYLESHEETPATH . '/headers/' . $stmeta2011headeror . '/image-01.jpg')) {
$head2011dir = get_bloginfo('stylesheet_directory');
} else {
$head2011dir = get_bloginfo('template_url');
}

register_default_headers(array(
'st_head01' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-01.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-01-thumbnail.jpg',
'description' => __('Stallion Header 1', 'stallion')
),
'st_head02' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-02.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-02-thumbnail.jpg',
'description' => __('Stallion Header 2', 'stallion')
),
'st_head03' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-03.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-03-thumbnail.jpg',
'description' => __('Stallion Header 3', 'stallion')
),
'st_head04' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-04.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-04-thumbnail.jpg',
'description' => __('Stallion Header 4', 'stallion')
),
'st_head05' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-05.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-05-thumbnail.jpg',
'description' => __('Stallion Header 5', 'stallion')
),
'st_head06' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-06.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-06-thumbnail.jpg',
'description' => __('Stallion Header 6', 'stallion')
),
'st_head07' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-07.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-07-thumbnail.jpg',
'description' => __('Stallion Header 7', 'stallion')
),
'st_head08' => array(
'url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-08.jpg',
'thumbnail_url' => '' . $head2011dir . '/headers/' . $stmeta2011headeror . '/image-08-thumbnail.jpg',
'description' => __('Stallion Header 8', 'stallion')
)
));
}

endif; // stallion_setup2

if (!function_exists('stallion_header_style')) :

/**
 * Styles the header image and text displayed on the blog
 *
 * @since Stallion Responsive 6.1
 */
function stallion_header_style() {

// If no custom options for text are set, let's bail
// get_header_textcolor() options: HEADER_TEXTCOLOR is default, hide text (returns 'blank') or any hex value
if (HEADER_TEXTCOLOR == get_header_textcolor())
return;
// If we get this far, we have custom styles. Let's do this.
?>
<style type="text/css">
<?php
// Has the text been hidden?
if ('blank' == get_header_textcolor()) :
?>
#header_stallion_2011_top {
position: absolute !important;
clip: rect(1px 1px 1px 1px); /* IE6, IE7 */
clip: rect(1px, 1px, 1px, 1px);
}
<?php
// If the user has set a custom color for the text use that
else :
?>
.site-title a,
#site-description, .description {
color: #<?php echo get_header_textcolor(); ?> !important;
}
<?php endif; ?>
</style>
<?php
}

endif; // stallion_header_style

if (!function_exists('stallion_admin_header_style')) :

/**
 * Styles the header image displayed on the Appearance > Header admin panel.
 *
 * Referenced via add_custom_image_header() in stallion_setup().
 *
 * @since Stallion Responsive 6.1
 */
function stallion_admin_header_style() {
?>
<style type="text/css">
.appearance_page_custom-header #headimg {
border: none;
background:#e8e8e8;
}
#headimg h1,
#desc {
font-family: Helvetica, Arial, Verdana, sans-serif;
}
#headimg h1 {
margin: 0;
}
#headimg h1 a {
font-size: 32px;
line-height: 36px;
text-decoration: none;
}
#desc {
font-size: 14px;
line-height: 23px;
padding: 0 0 3em;
}
<?php
// If the user has set a custom color for the text use that
if (get_header_textcolor() != HEADER_TEXTCOLOR) :
?>
.site-title a,
#site-description, .description {
color: #<?php echo get_header_textcolor(); ?>;
}
<?php endif; ?>
#headimg img {
max-width: 1000px;
height: auto;
width: 100%;
}
</style>
<?php
}

endif; // stallion_admin_header_style

if (!function_exists('stallion_admin_header_image')) :

/**
 * Custom header image markup displayed on the Appearance > Header admin panel.
 *
 * Referenced via add_custom_image_header() in stallion_setup().
 *
 * @since Stallion Responsive 6.1
 */
#$custom_header_support['default-text-color']
function stallion_admin_header_image() {
?>
<div id="headimg">
<?php
if ('blank' == get_theme_mod('header_textcolor', HEADER_TEXTCOLOR) || '' == get_theme_mod('header_textcolor', HEADER_TEXTCOLOR))
$style = ' style="display:none;"';
else
$style = ' style="color:#' . get_theme_mod('header_textcolor', HEADER_TEXTCOLOR) . ';"';
?>
<h1><a id="name"<?php echo $style; ?> onclick="return false;" href="<?php echo esc_url(home_url('/')); ?>"><?php bloginfo('name'); ?></a></h1>
<div id="desc"<?php echo $style; ?>><?php bloginfo('description'); ?></div>
<?php
$header_image = get_header_image();
if (!empty($header_image)) :
?>
<img src="<?php echo esc_url($header_image); ?>" alt="" />
<?php endif; ?>
</div>
<?php
}

endif; // stallion_admin_header_image
?>