<?php

add_filter('cmb_meta_boxes', 'stallion_featured_meta_post');

/**
 * Define the metabox and field configurations.
 *
 * @param  array $meta_boxes
 * @return array
 */
function stallion_featured_meta_post(array $meta_boxes) {

// Start with an underscore to hide fields from custom fields list
$prefix = '';

$meta_boxes[] = array(
'id' => 'stallion_featured_thumbnail',
'title' => 'Stallion Featured Thumbnail Options',
'pages' => array('post'), // Post type
'context' => 'normal',
'priority' => 'high',
'show_names' => true, // Show field names on the left
'fields' => array(
array(
'name' => 'Thumbnail',
'desc' => 'Upload/Select an image to use as a Thumbnail on archive pages and/or the Featured Slideshow and the Stallion Posts Widget. Stallion uses Timthumb 2 to crop and resize images. This means you can use very large images that Stallion will generate small images saving bandwidth.',
'id' => $prefix . 'thumb',
'type' => 'file',
),
array(
'name' => 'Use in Featured Slideshow',
'desc' => 'Checking this box will add this post to the Featured Slideshow using the above image. It is recommended to use an image size appropriate for the Stallion Sidebar Layout selected under Stallion "Layout Options"<br /><br /><strong>While under Stallion "Colour Options" - "Slideshow Position" set to "Below Header Main Content Width"</strong><br />410px sidebar layouts - 560px by 300px<br />310px sidebar layouts - 650px by 300px<br />255px and 165px layouts - 550px by 300px<br />Double 200px sidebar layouts - 560px by 300px<br />210px wide sidebar - 760px by 300px<br />No Sidebars layout - 970px by 300px.<br /><br /><strong>While under Stallion "Colour Options" - "Slideshow Position" set to "Below Header Full Screen Width"</strong><br />All Layouts - 970px by 300px<br /><br />This feature is mobile responsive, the slideshow box fits the device window overriding the default image sizes.<br /><br />Stallion uses Timthumb to zoom/crop images, so they don`t have to be the exact sizes above, for best results use the perfect size or bigger to avoid images scaling up: for example if you always use an image at least 970px by 300px it will never scale up.<br /><br />See the Stallion "Colour Options" page for more Featured Slideshow settings.',
'id' => $prefix . 'featured',
'type' => 'checkbox',
),
),
);
return $meta_boxes;
}

add_action('init', 'stallion_featured_meta_post_init', 9998);

/**
 * Initialize the metabox class.
 */
function stallion_featured_meta_post_init() {
if (!class_exists('cmb_Meta_Box'))
require_once 'init.php';
}

?>
<?php

add_filter('cmb_meta_boxes', 'stallion_featured_meta_page');

/**
 * Define the metabox and field configurations.
 *
 * @param  array $meta_boxes
 * @return array
 */
function stallion_featured_meta_page(array $meta_boxes) {

// Start with an underscore to hide fields from custom fields list
$prefix = '';

$meta_boxes[] = array(
'id' => 'stallion_featured_thumbnail',
'title' => 'Stallion Featured Thumbnail Options',
'pages' => array('page'), // Post type
'context' => 'normal',
'priority' => 'high',
'show_names' => true, // Show field names on the left
'fields' => array(
array(
'name' => 'Thumbnail',
'desc' => 'Upload/Select an image to use as a Thumbnail on archive pages and/or the Featured Slideshow and the Stallion Posts Widget. Stallion uses Timthumb 2 to crop and resize images. This means you can use very large images that Stallion will generate small images saving bandwidth.',
'id' => $prefix . 'thumb',
'type' => 'file',
),
),
);
return $meta_boxes;
}

add_action('init', 'stallion_featured_meta_page_init', 9998);

/**
 * Initialize the metabox class.
 */
function stallion_featured_meta_page_init() {
if (!class_exists('cmb_Meta_Box'))
require_once 'init.php';
}

?>
<?php
add_filter('cmb_meta_boxes', 'stallion_top_banner_meta_post');
function stallion_top_banner_meta_post(array $meta_boxes) {
$prefix = '';

$meta_boxes[] = array(
'id' => 'stallion_top_banner_image',
'title' => 'Stallion Top Banner Image Options',
'pages' => array('post', 'page'),
'context' => 'normal',
'priority' => 'high',
'show_names' => true,
'fields' => array(
array(
'name' => 'Top Banner Image',
'desc' => 'Upload/Select an image to use as a "Top Banner Image" for this post only and/or as a "Stallion 2011 Header Image" for this post only.<br />This image will be shown instead of a Random Top Banner Image (set under Stallion Colour Options >> Top Banner Set) and/or instead of a Random Header Image (set under Stallion Colour Options >> Stallion 2011 Header Image Sets). For the Top Banner Image Stallion uses Timthumb 2 to crop and resize images on the fly, this means you can use very large images that Stallion will generate small images saving bandwidth. The full size image is used as the Stallion 2011 Header image, for best results use an image with dimensions exactly 1000px wide by 288px height (works perfectly for both the banners and headers).<br /><br />Stallion includes two image media sizes that have width 1000px (generated from images at least 1000px wide).<br />large-feature: exactly 1000px by 288px, the image is resized to 1000px wide and the top and bottom cropped to 288px height (the 288px is the center of the image).<br />stallion-header: 1000px by XXXpx, the image is resized to 1000px wide, the height is reduced by the same ratio (nothing cropped: full image, but smaller), so the height is unlikely to be 288px.<br /><br />Best solution is create an image offline with dimensions 1000px x 288px and upload here.',
'id' => $prefix . 'st_meta_top_banner_post',
'type' => 'file',
),
array(
'name' => 'How to Use Image',
'desc' => 'The above image can have two uses, set as a top banner image (above main content) and/or as a 2011 header image (large 1000px by 288px image near the top of the page). The 6 selections above cover all possible uses including overriding main Stallion Options.<br /><br />1 : Use when a "Top Banner Set" is selected under "Stallion Colour Options".<br />2 : Use no matter how "Top Banner Set" is set.<br />3 : Selection 1 AND use as a Stallion 2011 Header Image on this post.<br />4 : Selection 2 AND use as a Stallion 2011 Header Image on this post.<br />5 : Use as 2011 Header Image Only on this post.<br />6 : Selection 5 even when under "Appearance >> Headers : No Image Set" - you clicked the "Remove Header Image" button.<br /><br />Selections 3 and 4 result in the image being used twice (not a good idea). Note: For this feature to work perfectly please use an image with dimensions 1000px by 288px.',
'id' => $prefix . 'st_meta_top_banner_post_use',
'type' => 'select',
'options' => array(
array('name' => '1 Use As Top Banner Only when Top Banners On', 'value' => '1',),
array('name' => '2 Use As Top Banner Only when Top Banners On or Off', 'value' => '2',),
array('name' => '3 Use As Top Banner when Top Banners On AND Use as 2011 Header Image', 'value' => '3',),
array('name' => '4 Use As Top Banner when Top Banners On or Off AND Use as 2011 Header Image', 'value' => '4',),
array('name' => '5 Use as 2011 Header Image Only', 'value' => '5',),
array('name' => '6 Use as 2011 Header Image Only when Remove Header Image Set', 'value' => '6',),
),
),
),
);
return $meta_boxes;
}

add_action('init', 'stallion_top_banner_meta_post_init', 9998);

function stallion_top_banner_meta_post_init() {
if (!class_exists('cmb_Meta_Box'))
require_once 'init.php';
}
?>