<?php

add_filter('cmb_meta_boxes', 'stallion_layout_meta_post');

/**
 * Define the metabox and field configurations.
 *
 * @param  array $meta_boxes
 * @return array
 */
function stallion_layout_meta_post(array $meta_boxes) {

$st_layout_array = array(
array('name' => 'Default Layout', 'value' => '',),
array('name' => '1 - Main Content 760px : Left Sidebar 210px', 'value' => '210l',),
array('name' => '2 - Main Content 760px : Right Sidebar 210px', 'value' => '210r',),
array('name' => '3 - Main Content 660px : Left Sidebar 310px', 'value' => '310l',),
array('name' => '4 - Main Content 660px : Right Sidebar 310px', 'value' => '310r',),
array('name' => '5 - Main Content 560px : Left Sidebar 410px', 'value' => '410l',),
array('name' => '6 - Main Content 560px : Right Sidebar 410px', 'value' => '410r',),
array('name' => '7 - Main Content 560px : Left Sidebar 200px : Right Sidebar 200px', 'value' => '200l200r',),
array('name' => '8 - Main Content 560px : Left Sidebar 200px : Left Sidebar 200px', 'value' => '200l200l',),
array('name' => '9 - Main Content 560px : Right Sidebar 200px : Right Sidebar 200px', 'value' => '200r200r',),
array('name' => '10 - Main Content 550px : Left Sidebar 255px : Left Sidebar 165px', 'value' => '255l165l',),
array('name' => '11 - Main Content 550px : Right Sidebar 255px : Right Sidebar 165px', 'value' => '255r165r',),
array('name' => '12 - Main Content : No Sidebars', 'value' => '1000',),
array('name' => 'Custom 01', 'value' => 'custom-01',),
);
if (function_exists('stc_child_layout')) {
$st_layout_array_ch = stc_child_layout();
} else {
$st_layout_array_ch = array(
array('name' => '', 'value' => ' ',),
);
}
$st_layout_result = array_merge($st_layout_array, $st_layout_array_ch);

$st_colour_array = array(
array('name' => 'Default Colour', 'value' => '',),
array('name' => 'Basic Defaults', 'value' => 'basic-defaults',),
array('name' => 'Basic Defaults Rounded Corners', 'value' => 'basic-defaults-rc',),
array('name' => 'Light', 'value' => 'light',),
array('name' => 'Light Rounded Corners', 'value' => 'light-rc',),
array('name' => 'White n Blue', 'value' => 'white-n-blue',),
array('name' => 'White n Blue Rounded Corners', 'value' => 'white-n-blue-rc',),
array('name' => 'White n Red', 'value' => 'white-n-red',),
array('name' => 'White n Red Rounded Corners', 'value' => 'white-n-red-rc',),
array('name' => 'Charcoal n Orange', 'value' => 'charcoal-n-orange',),
array('name' => 'Charcoal n Orange Rounded Corners', 'value' => 'charcoal-n-orange-rc',),
array('name' => 'Black n White', 'value' => 'black-n-white',),
array('name' => 'Black n White Rounded Corners', 'value' => 'black-n-white-rc',),
array('name' => 'Black n Blue', 'value' => 'black-n-blue',),
array('name' => 'Black n Blue Rounded Corners', 'value' => 'black-n-blue-rc',),
array('name' => 'Black n Red', 'value' => 'black-n-red',),
array('name' => 'Black n Red Rounded Corners', 'value' => 'black-n-red-rc',),
array('name' => 'Black n Green', 'value' => 'black-n-green',),
array('name' => 'Black n Green Rounded Corners', 'value' => 'black-n-green-rc',),
array('name' => 'Dark', 'value' => 'dark',),
array('name' => 'Dark Rounded Corners', 'value' => 'dark-rc',),
array('name' => '50 Shades of Grey', 'value' => 'shades-grey',),
array('name' => '50 Shades of Grey Rounded Corners', 'value' => 'shades-grey-rc',),
array('name' => 'Radiant Orchard', 'value' => 'radiant-orchard',),
array('name' => 'Radiant Orchard Rounded Corners', 'value' => 'radiant-orchard-rc',),
array('name' => 'Dazzling Blue and Cayenne', 'value' => 'dazzling-blue-cayenne',),
array('name' => 'Dazzling Blue and Cayenne Rounded Corners', 'value' => 'dazzling-blue-cayenne-rc',),
array('name' => 'Midnight Slate', 'value' => 'midnight-slate',),
array('name' => 'Midnight Slate Rounded Corners', 'value' => 'midnight-slate-rc',),
array('name' => 'Coffee Cup', 'value' => 'coffee-cup',),
array('name' => 'Coffee Cup Rounded Corners', 'value' => 'coffee-cup-rc',),
array('name' => 'Green Tea Tones by Marie', 'value' => 'green-tea-tones',),
array('name' => 'Green Tea Tones Rounded Corners by Marie', 'value' => 'green-tea-tones-rc',),
array('name' => 'Fresh n Green by Marie', 'value' => 'fresh-n-green',),
array('name' => 'Fresh n Green Rounded Corners by Marie', 'value' => 'fresh-n-green-rc',),
array('name' => 'Blue Door Tones by Marie', 'value' => 'blue-door-tones',),
array('name' => 'Blue Door Rounded Corners Tones by Marie', 'value' => 'blue-door-tones-rc',),
array('name' => 'Night Sky by Marie', 'value' => 'night-sky',),
array('name' => 'Night Sky Rounded Corners Tones by Marie', 'value' => 'night-sky-rc',),
array('name' => 'Celebrate by Marie', 'value' => 'celebrate',),
array('name' => 'Celebrate Rounded Corners Tones by Marie', 'value' => 'celebrate-rc',),
array('name' => 'Custom 01', 'value' => 'custom-01',),
array('name' => 'Custom 02', 'value' => 'custom-02',),
array('name' => 'Custom 03', 'value' => 'custom-03',),
array('name' => 'Custom 04', 'value' => 'custom-04',),
array('name' => 'Custom 05', 'value' => 'custom-05',),
);
if (function_exists('stc_child_colours')) {
$st_colour_array_ch = stc_child_colours();
} else {
$st_colour_array_ch = array(
array('name' => '', 'value' => ' ',),
);
}
$st_colour_result = array_merge($st_colour_array, $st_colour_array_ch);

$st_stheader_array = array(
array('name' => 'Default Header', 'value' => '',),
array('name' => 'Arty 2', 'value' => 'arty2-st.jpg',),
array('name' => 'Business 1', 'value' => 'business1-st.jpg',),
array('name' => 'Money 100 Dollars', 'value' => '20.gif',),
array('name' => 'Orange Flower', 'value' => '1.jpg',),
array('name' => 'Twenty Eleven', 'value' => '26.jpg',),
array('name' => 'custom 1 jpg', 'value' => 'c1.jpg',),
array('name' => 'custom 2 jpg', 'value' => 'c2.jpg',),
array('name' => 'custom 3 jpg', 'value' => 'c3.jpg',),
array('name' => 'custom 4 jpg', 'value' => 'c4.jpg',),
array('name' => 'custom 5 jpg', 'value' => 'c5.jpg',),
array('name' => 'custom 1 gif', 'value' => 'c1.gif',),
array('name' => 'custom 2 gif', 'value' => 'c2.gif',),
array('name' => 'custom 3 gif', 'value' => 'c3.gif',),
array('name' => 'custom 4 gif', 'value' => 'c4.gif',),
array('name' => 'custom 5 gif', 'value' => 'c5.gif',),
);
if (function_exists('stc_child_stheader')) {
$st_stheader_array_ch = stc_child_stheader();
} else {
$st_stheader_array_ch = array(
array('name' => '', 'value' => ' ',),
);
}
$st_stheader_result = array_merge($st_stheader_array, $st_stheader_array_ch);

$st_2011header_array = array(
array('name' => 'Default 2011 Header', 'value' => '',),
array('name' => 'Business', 'value' => 'business-st',),
array('name' => 'Custom 01', 'value' => 'custom-01',),
array('name' => 'Custom 02', 'value' => 'custom-02',),
array('name' => 'Custom 03', 'value' => 'custom-03',),
array('name' => 'Custom 04', 'value' => 'custom-04',),
array('name' => 'Custom 05', 'value' => 'custom-05',),
array('name' => 'Custom 06', 'value' => 'custom-06',),
array('name' => 'Custom 07', 'value' => 'custom-07',),
array('name' => 'Custom 08', 'value' => 'custom-08',),
array('name' => 'Custom 09', 'value' => 'custom-09',),
array('name' => 'Custom 10', 'value' => 'custom-10',),
);
if (function_exists('stc_child_2011header')) {
$st_2011header_array_ch = stc_child_2011header();
} else {
$st_2011header_array_ch = array(
array('name' => '', 'value' => ' ',),
);
}
$st_2011header_result = array_merge($st_2011header_array, $st_2011header_array_ch);

$st_topbanners_array = array(
array('name' => 'Default Top Banners', 'value' => '',),
array('name' => 'Business', 'value' => 'business-st',),
array('name' => 'Custom 01', 'value' => 'custom-01',),
array('name' => 'Custom 02', 'value' => 'custom-02',),
array('name' => 'Custom 03', 'value' => 'custom-03',),
array('name' => 'Custom 04', 'value' => 'custom-04',),
array('name' => 'Custom 05', 'value' => 'custom-05',),
array('name' => 'Custom 06', 'value' => 'custom-06',),
array('name' => 'Custom 07', 'value' => 'custom-07',),
array('name' => 'Custom 08', 'value' => 'custom-08',),
array('name' => 'Custom 09', 'value' => 'custom-09',),
array('name' => 'Custom 10', 'value' => 'custom-10',),
);
if (function_exists('stc_child_top_banners')) {
$st_topbanners_array_ch = stc_child_top_banners();
} else {
$st_topbanners_array_ch = array(
array('name' => '', 'value' => ' ',),
);
}
$st_topbanners_result = array_merge($st_topbanners_array, $st_topbanners_array_ch);

$st_adsoff_array = array(
array('name' => 'Default Ads Setup', 'value' => '',),
array('name' => 'All Ads On', 'value' => 'on',),
array('name' => 'All Ads Off', 'value' => 'off',),
);
if (function_exists('stc_child_adsoff')) {
$st_adsoff_array_ch = stc_child_adsoff();
} else {
$st_adsoff_array_ch = array(
array('name' => '', 'value' => ' ',),
);
}
$st_adsoff_result = array_merge($st_adsoff_array, $st_adsoff_array_ch);

// Start with an underscore to hide fields from custom fields list
$prefix = '';

$meta_boxes[] = array(
'id' => 'stallion_layout_ovride',
'title' => 'Stallion Layout and Colour Scheme Options',
'pages' => array('post', 'page'), // Post type
'context' => 'normal',
'priority' => 'high',
'show_names' => true, // Show field names on the left
'fields' => array(
array(
'name' => 'Sidebar Layout',
'desc' => 'Select a Sidebar Layout for this Post.',
'id' => $prefix . 'st_meta_layout_or',
'type' => 'select',
'options' => $st_layout_result,
),
array(
'name' => 'Colour Scheme',
'desc' => 'Select a Colour for this Post.',
'id' => $prefix . 'st_meta_colour_or',
'type' => 'select',
'options' => $st_colour_result,
),
array(
'name' => 'Original Header',
'desc' => 'Select a Stallion Original Header for this Post.',
'id' => $prefix . 'st_meta_header_or',
'type' => 'select',
'options' => $st_stheader_result,
),
array(
'name' => '2011 Header Set',
'desc' => 'Select a Stallion 2011 Header Set for this Post. Note only works with the Random setting under Appearance >> Headers, one of eight random headers will show from the above set.',
'id' => $prefix . 'st_meta_2011header_or',
'type' => 'select',
'options' => $st_2011header_result,
),
array(
'name' => 'Top Banners',
'desc' => 'Select a Stallion Top banner Set for this Post.',
'id' => $prefix . 'st_meta_top_banners_or',
'type' => 'select',
'options' => $st_topbanners_result,
),
array(
'name' => 'Disable All Ads',
'desc' => 'Disable AdSense and Chitika Ads. Note does not disable widget ad units.<br /><br />If you are running a <a href="http://stallion-theme.co.uk/stallion-responsive-child-theme/" target="_blank">child theme</a> please be aware if you choose child theme options above and later disable the child theme or change child themes the setting will break. A solution is copy relevant files from the child theme folder to either the new child theme or directly into Stallion.',
'id' => $prefix . 'st_meta_adsoff_or',
'type' => 'select',
'options' => $st_adsoff_result,
),
),
);
return $meta_boxes;
}

add_action('init', 'stallion_layout_meta_post_init', 9998);

/**
 * Initialize the metabox class.
 */
function stallion_layout_meta_post_init() {
if (!class_exists('cmb_Meta_Box'))
require_once 'init.php';
}

?>
<?php

function stmetaadsoffor() {
global $post;
if (get_post_meta($post->ID, 'st_meta_adsoff_or', true)) :
$stmetaadsoffor = get_post_meta($post->ID, 'st_meta_adsoff_or', true);
else :
$stmetaadsoffor = 'on';
endif;
return $stmetaadsoffor;
}

?>