<?php
function stallion_youtube_widget() {
register_widget('st_youtube_widget');
}

add_action('widgets_init', 'stallion_youtube_widget');

class st_youtube_widget extends WP_Widget {

function st_youtube_widget() {
$widget_ops = array(
'classname' => 'st_youtube',
'description' => __('Include recent YouTube videos from a YouTube Users RSS Feed with RSS URL format http://gdata.youtube.com/feeds/base/users/CrayzyFool/uploads', 'Stallion')
);
$control_ops = array(
'width' => '300',
'height' => '300',
'id_base' => 'stallion_youtube_widget'
);
$this->WP_Widget('stallion_youtube_widget', __('Stallion YouTube RSS Widget', 'Stallion'), $widget_ops
#, $control_ops
);
}

function widget($args, $instance) {
extract($args);
$st_yt_widget_title = apply_filters('widget_title', $instance['st_yt_widget_title']);
$st_yt_video_number = $instance['st_yt_video_number'];
$st_yt_video_width = $instance['st_yt_video_width'];
$st_yt_video_height = $instance['st_yt_video_height'];
$st_yt_rss_feed = $instance['st_yt_rss_feed'];
$st_yt_rss_title = $instance['st_yt_rss_title'];

echo $before_widget;
if ($st_yt_widget_title)
echo $before_title . $st_yt_widget_title . $after_title;
?>
<?php
$count = '1';
if(! class_exists('SimplePie')){
require_once(ABSPATH . WPINC . '/class-simplepie.php');
}

$yurl = $instance['st_yt_rss_feed'];
$rss = @fetch_feed($yurl);
if (!is_wp_error($rss)) :
$st_max_vids = $instance['st_yt_video_number'];
$maxitems = $rss->get_item_quantity( $st_max_vids ); 
$items = $rss->get_items(0, $maxitems); 

foreach ($items as $item) :
#$st_youtube_id = strchr($item['link'], '=');
$st_youtube_id = esc_url( $item->get_permalink() ); 
#$st_youtube_id = substr($st_youtube_id, 1);
$st_video_width = $instance['st_yt_video_width'];
$st_youtube_id = str_replace('http://www.youtube.com/watch?v=', 'https://www.youtube.com/embed/', $st_youtube_id);
$st_youtube_id = str_replace('&#038;feature=youtube_gdata', '?feature=oembed', $st_youtube_id);
$st_rss_title = $instance['st_yt_rss_title'];
?>
<?php if ($st_rss_title == 'yes') : ?><strong><?php echo esc_html( $item->get_title() ); ?></strong><?php endif; ?>
<div class="styoutube"><iframe height="<?php echo $instance['st_yt_video_height']; ?>" width="<?php echo $instance['st_yt_video_width']; ?>" src="<?php echo $st_youtube_id ?>" frameborder="0" allowfullscreen></iframe></div>
<?php $count = $count + 1;
endforeach; 
endif;
?>
<?php
echo $after_widget;
}

function form($instance) {
$defaults = array(
'st_yt_widget_title' => __('Recent YouTube Videos', 'stallion'),
'st_yt_rss_title' => 'no',
'st_yt_video_width' => '300',
'st_yt_video_height' => '200',
'st_yt_video_number' => '1',
'st_yt_rss_feed' => 'http://gdata.youtube.com/feeds/base/users/CrayzyFool/uploads'
);

$instance = wp_parse_args((array) $instance, $defaults);
?>

<p><label for="<?php echo $this->get_field_id('st_yt_widget_title'); ?>"><?php _e('Title:', 'stallion'); ?></label>
<input id="<?php echo $this->get_field_id('st_yt_widget_title'); ?>" name="<?php echo $this->get_field_name('st_yt_widget_title'); ?>" value="<?php echo $instance['st_yt_widget_title']; ?>" style="width:100%;" /></p>
<p><label for="<?php echo $this->get_field_id('st_yt_video_width'); ?>"><?php _e('Video Width: Ignored, now Responsive 16:9 Ratio', 'stallion'); ?></label>
<input id="<?php echo $this->get_field_id('st_yt_video_width'); ?>" name="<?php echo $this->get_field_name('st_yt_video_width'); ?>" value="<?php echo $instance['st_yt_video_width']; ?>" style="width:100%;" /></p>
<p><label for="<?php echo $this->get_field_id('st_yt_video_height'); ?>"><?php _e('Video Height: Ignored, now Responsive 16:9 Ratio', 'stallion'); ?></label>
<input id="<?php echo $this->get_field_id('st_yt_video_height'); ?>" name="<?php echo $this->get_field_name('st_yt_video_height'); ?>" value="<?php echo $instance['st_yt_video_height']; ?>" style="width:100%;" /></p>
<p><label for="<?php echo $this->get_field_id('st_yt_video_number'); ?>"><?php _e('Number of YouTube videos to show:', 'stallion'); ?></label>
<input id="<?php echo $this->get_field_id('st_yt_video_number'); ?>" name="<?php echo $this->get_field_name('st_yt_video_number'); ?>" value="<?php echo $instance['st_yt_video_number']; ?>" style="width:100%;" /></p>
<p><label for="<?php echo $this->get_field_id('st_yt_rss_title'); ?>"><?php _e('Show YouTube Video Title Above Videos', 'stallion') ?></label>
<select id="<?php echo $this->get_field_id('st_yt_rss_title'); ?>" name="<?php echo $this->get_field_name('st_yt_rss_title'); ?>" class="widefat" style="width:100%;">
<option value="yes" <?php if ('yes' == $instance['st_yt_rss_title']) { echo "selected='selected'"; } ?>><?php _e('Yes', 'stallion'); ?></option>
<option value="no" <?php if ('no' == $instance['st_yt_rss_title']) { echo "selected='selected'"; } ?>><?php _e('No', 'stallion'); ?></option>
</select></p>
<p><label for="<?php echo $this->get_field_id('st_yt_rss_feed'); ?>"><?php _e('Youtube User RSS Feed:', 'stallion'); ?></label>
<textarea rows="3" id="<?php echo $this->get_field_id('st_yt_rss_feed'); ?>" name="<?php echo $this->get_field_name('st_yt_rss_feed'); ?>" style="width:100%;"><?php echo $instance['st_yt_rss_feed']; ?></textarea></p>
<?php }
} ?>